# Expected varibles:
# BACKSTAGE_TECHDOCS_AZURE_TENANT_ID: setup per group
# BACKSTAGE_TECHDOCS_AZURE_CLIENT_ID: setup per group
# BACKSTAGE_TECHDOCS_AZURE_CLIENT_SECRET: setup per group
# BACKSTAGE_ENTITY_NAME: define entity in Backstage, example: default/component/core

# TBD: create separate docker image repo

publish_backstage_tech_docs:
    stage: deploy
    image: node:20.18.0-bullseye
    script:
        - npm install -g @techdocs/cli@1.8.18
        - apt-get update && apt-get install -y python3 python3-pip python3-venv
        - export VIRTUAL_ENV=/opt/venv
        - python3 -m venv $VIRTUAL_ENV
        - export PATH="$VIRTUAL_ENV/bin:$PATH"
        - pip3 install "mkdocs-techdocs-core==1.2.3"
        - techdocs-cli generate --no-docker
        - export AZURE_TENANT_ID="${BACKSTAGE_TECHDOCS_AZURE_TENANT_ID}"
        - export AZURE_CLIENT_ID="${BACKSTAGE_TECHDOCS_AZURE_CLIENT_ID}"
        - export AZURE_CLIENT_SECRET="${BACKSTAGE_TECHDOCS_AZURE_CLIENT_SECRET}"
        - techdocs-cli publish --publisher-type azureBlobStorage --storage-name rabin-backstage-docs --azureAccountName rabingolemio --entity $BACKSTAGE_ENTITY_NAME
    only:
        - master
        - main
